function [val,Dval,D2val]=rosenbrock(x)

%--------------------------------------------------------------------------
% Rosenbrock function
%
% global minimum at [1,1] with rosenbrock([1,1])=0
%--------------------------------------------------------------------------
% KIT/IOR - 04/02/2012
%--------------------------------------------------------------------------

val = 100*(x(2)-x(1).^2).^2+(1-x(1)).^2;

if nargout>1
    Dval = [-400*(x(2)-x(1).^2)*x(1)-2+2*x(1);...
              200*x(2)-200*x(1).^2            ];
    if nargout>2
        D2val =  [1200*x(1)^2-400*x(2)+2, -400*x(1);...
                               -400*x(1),  200      ];
    end
end
